// config

// wb_[
#include <pspkernel.h>
#include <pspsysmem.h>
#include <string.h>
#include <stdlib.h>
#include "conf.h"

// ֐
void *malloc_p(SceSize size)
{
	SceUID memid;
	void *p;

	// m
	memid = sceKernelAllocPartitionMemory(2, "block_mem", 0, size, NULL);
	if(memid < 0) return NULL;

	// mۂ̃|C^擾
	p = (void *)sceKernelGetBlockHeadAddr(memid);
	return p;
}

int ReadLine(SceUID fd, char *buf, int n)
{
	int res, i = 0;
	char ch;

	do
	{
		res = sceIoRead(fd, &ch, 1);

		if(ch == '\r' || ch == ' ') continue;
		else if(ch == '\n') break;

		else
		{
			buf[i++] = ch;
		}
	}
	while(res > 0 && i < n);

	buf[i] = '\0';
	return i;
}

int Check_EOF(SceUID fd)
{
	char ch;

	if(sceIoRead(fd, &ch, 1) == 1)
	{
		sceIoLseek(fd, -1, PSP_SEEK_CUR);
		return 0;
	}

	return 1;
}

int GetConfigPath(char *buf)
{
	char *p = strrchr(buf, '/');
	if(!p) return -1;

	p++;
	*p++ = 'b';
	*p++ = 'r';
	*p++ = 'i';
	*p++ = 'g';
	*p++ = 'h';
	*p++ = 't';
	*p++ = '3';
	*p++ = '.';
	*p++ = 'i';
	*p++ = 'n';
	*p++ = 'i';
	*p = '\0';

	return 0;
}

int CountItem(char *file)
{
	int count = 0;
	char buffer[256];

	SceUID fd = sceIoOpen(file, PSP_O_RDONLY, 0777);
	if(fd < 0)
	{
		file[0] = 'm';
		file[1] = 's';

		fd = sceIoOpen(file, PSP_O_RDONLY, 0777);
		if(fd < 0) return -1;
	}

	while(Check_EOF(fd) == 0)
	{
		ReadLine(fd, buffer, 256);

		if(buffer[0] != '\0' && buffer[0] != '#')
		{
			count++;
		}
	}

	sceIoClose(fd);
	return count;
}

int ReadItem(const char *file, Bright *buf)
{
	int count = 0;
	char buffer[256];

	SceUID fd = sceIoOpen(file, PSP_O_RDONLY, 0777);
	if(fd < 0) return -1;

	while(Check_EOF(fd) == 0)
	{
		ReadLine(fd, buffer, 256);

		if(buffer[0] != '\0' && buffer[0] != '#')
		{
			buf[count++].level = (int)atoi(buffer);
		}
	}

	sceIoClose(fd);
	return count;
}

